#!/usr/bin/wish

#BEGIN LICENSE
#
#    Scopone Scientifico versione 4.1
#    Copyright (C) 2009  Antonio Iacono (antonio2@blia.it)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#END LICENSE

package require http 2.0

set trunk 1
set url http://www.blia.it/cgi-bin/scopone.pl
set tipogioco 9
set modalita 0
set nome1 ""
set nome2 ""
set nome3 ""
set nome4 ""
set punteggio12 0
set punteggio34 0
set ngame ""
set aspetta 1
set ngiocatore 4
set chisono 0
set tipicarte 0
set magic_number 0

   proc menu:create {w menulist} {
   if {$w=="."} {set w2 ""} else {set w2 $w}
   menu $w2.menubar; $w config -menu $w2.menubar
   foreach {hdr items} $menulist {menu:add $w $hdr $items}
   }

proc regole {} {
    global tk_library
    global trunk
    if {$trunk} {
    set file istruzioni
    } else {
    set file /scopone41/istruzioni
    }
    if ![winfo exists .code] {
	toplevel .code
	frame .code.buttons
	pack .code.buttons -side bottom -fill x
	button .code.buttons.dismiss -text Chiudi \
            -default active -command "destroy .code"
	pack .code.buttons.dismiss -side left \
	    -expand 1 -pady 2
	frame .code.frame
	pack  .code.frame -expand yes -fill both -padx 1 -pady 1
	text .code.text -height 40 -wrap word\
	    -xscrollcommand ".code.xscroll set" \
	    -yscrollcommand ".code.yscroll set" \
	    -setgrid 1 -highlightthickness 0 -pady 2 -padx 3
	scrollbar .code.xscroll -command ".code.text xview" \
	    -highlightthickness 0 -orient horizontal
	scrollbar .code.yscroll -command ".code.text yview" \
	    -highlightthickness 0 -orient vertical

	grid .code.text -in .code.frame -padx 1 -pady 1 \
	    -row 0 -column 0 -rowspan 1 -columnspan 1 -sticky news
	grid .code.yscroll -in .code.frame -padx 1 -pady 1 \
	    -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news
	grid rowconfig    .code.frame 0 -weight 1 -minsize 0
	grid columnconfig .code.frame 0 -weight 1 -minsize 0
    } else {
	wm deiconify .code
	raise .code
    }
    wm title .code "Le regole di Chitarella"
    wm iconname .code $file
    set id [open [file join $file]]
    .code.text delete 1.0 end
    .code.text insert 1.0 [read $id]
    .code.text mark set insert 1.0
    close $id
}




   proc menu:add {w top descr} {
   if {$w=="."} {set w ""}
   set it $w.menubar.m$top
   if {![winfo exists $it]} {
        menu $it
        $w.menubar add cascade -label $top -menu $it -underline 0
   }
   foreach {label cmd} $descr {
   if {$label=="--"} {$it add separator; continue}
   if {[regexp {^-(.+)} $label -> label]} {
        set state disabled
        } else {set state normal}
        if ![catch {$it index $label}] continue;
        if {[regexp {^x (.+)} $label -> label]} {
        regsub -all " " $label "_" xlabel
        $it add check -label $label -state $state\
                -variable ::$xlabel -command $cmd
                } elseif {[regexp {^R (.+)} $label ->label]} {
                catch {$it add cascade -label $label -menu $it.r$label}
                set radi [menu $it.r$label -tearoff 0]
                foreach {varname default} $cmd break
                global $varname
                set $varname $default
                foreach {txt cmd} [lrange $cmd 2 end] {
                $radi add radio -label $txt -variable $varname -command $cmd
                 }
                } else {
                $it add command -label $label -state $state -command $cmd
                }
               }
             }

    proc menu:delete {w to label} {
    if {$w=="."} { set w ""}
    set it $w.menubar.m$top
    catch {$it delete [$it index $label]}
    }

    proc menu_disable {w top args} {
    if {$w=="."} {set w ""}
    foreach a $args {
    catch {$w.menubar.m$top entryconfigure $a -state disabled}
    }
    }
    proc menu:enable {w top args} {
    if {$w=="."} {set w ""}
    foreach a $args {
    catch {$w.menubar.m$top entryconfigure $a -state normal}
    }
    }

proc tipomazzo {} {
global carta_img mazzo tipicarte carta_d carta_v trunk

if {$tipicarte == 0 || $tipicarte == 3} {
set valori {Asso Due Tre Quattro Cinque Sei Sette Donna Cavallo Re}
set semi {Denari Bastoni Coppe Spade}
}

if {$tipicarte == 1 || $tipicarte == 4 || $tipicarte == 5} {
set valori {Asso Due Tre Quattro Cinque Sei Sette Fante Cavallo Re}
set semi {Denari Bastoni Coppe Spade}
}

if {$tipicarte == 2} {
set valori {Asso Due Tre Quattro Cinque Sei Sette Fante Donna Re}
set semi {Quadri Fiori Cuori Picche}
}

set valori_n {1 2 3 4 5 6 7 8 9 10}

set prog1 0
foreach valori2 {1 2 3 4 5 6 7 d f r} {
	set prog2 0
	foreach semi2 {o b c s} {
		set carta_d($valori2$semi2) "[lindex $valori $prog1] di [lindex $semi $prog2]"
		set carta_v($valori2$semi2) [lindex $valori_n $prog1]
		incr prog2
	}
	incr prog1
}



foreach carta_img $mazzo {
set tipica ""
if {$tipicarte == 1} {
set tipica p
}
if {$tipicarte == 2} {
set tipica m
}
if {$tipicarte == 3} {
set tipica s
}
if {$tipicarte == 4} {
set tipica b
}
if {$tipicarte == 5} {
set tipica r
}


    if {$trunk} {
    image create photo $carta_img -file $carta_img$tipica.gif -format GIF
    } else {
    image create photo $carta_img -file /scopone41/$carta_img$tipica.gif -format GIF
    }



}
}

proc cancella {w} {

        global mazzo piatto uscite_gioc carte_pc ngiocatore carta_com giocatore pc_giocatore carta_d
        global nturno presesn preseeo scope ultimapresa uscitaciclo noboot modalita trunk

        if {$modalita == 0} {
        set ngiocatore 4
        }

	foreach {scope(1) scope(2) scope(3) scope(4)} {0 0 0 0} {}
        foreach {uscitaciclo ultimapresa nturno noboot} {1 1 1 1} {}
        foreach {piatto} { {} {} {} {} {} } {}
        foreach {giocatore(1) giocatore(2) giocatore(3) giocatore(4)} {Est Nord Ovest Sud} {}

        if {$modalita == 0} {
        foreach {pc_giocatore(1) pc_giocatore(2) pc_giocatore(3) pc_giocatore(4)} {0 0 0 0} {}
        }

	foreach {presesn preseeo uscite_gioc(1) uscite_gioc(2) uscite_gioc(3) uscite_gioc(4)} { {} {} {} {} {} {} } {}
	foreach {carte_pc(1) carte_pc(2) carte_pc(3) carte_pc(4) carta_com} { {} {} {} {} "" } {}

	destroy $w.e1computer
	destroy $w.e2computer
	destroy $w.e3computer

	destroy $w.nomi1
	destroy $w.nomi2
	destroy $w.nomi3
	destroy $w.nomi4

	foreach carta $mazzo {
	        destroy $w.c$carta
		destroy $w.e$carta
		set a 1
		destroy $w.e$carta$a
		set a 2
		destroy $w.e$carta$a
		set a 3
		destroy $w.e$carta$a
		set a 4
		destroy $w.e$carta$a
	}

	destroy $w.lbl01
	destroy $w.lbl02
	destroy $w.btn01
}

set w .t
toplevel $w
wm withdraw .
# wm geometry .t 720x557
wm geometry .t 795x525
wm title .t "Scopone scientifico 4.1 10/09"
wm resizable .t 0 0

wm protocol .t WM_DELETE_WINDOW { exit }

# 80 220
# 200 280 360 440 520
# set numpiatto "240170320170400170240070320070400070240270320270400270"
# set numpiatto "240180320180400180240060320060400060240290320290400290"
set numpiatto "280 80280220360 80360220200 80200220440 80440220520 80520220"
set mazzo {1o 2o 3o 4o 5o 6o 7o do fo ro 1s 2s 3s 4s 5s 6s 7s ds fs rs 1b 2b 3b 4b 5b 6b 7b db fb rb 1c 2c 3c 4c 5c 6c 7c dc fc rc}
set valosco {20 18 16 14 12 4 2 10 8 6 21 19 17 15 13 5 3 11 9 7 21 19 17 15 13 5 3 11 9 7 21 19 17 15 13 5 3 11 9 7}
set valo {201 145 159 173 187 229 817 117 117 118 110 54 68 82 96 138 280 26 26 27 110 54 68 82 96 138 280 26 26 27 110 54 68 82 96 138 280 26 26 27}
set valoss {13 9 10 11 12 18 30 14 15 16 5 1 2 3 4 17 19 6 7 8 5 1 2 3 4 17 19 6 7 8 5 1 2 3 4 17 19 6 7 8}
set finepa 0
set debug 0
set messdebug "presa"
cancella $w

if {$trunk} {
image create photo computer -file computer.gif -format GIF
image create photo uomo -file uomo.gif -format GIF
} else {
image create photo computer -file /scopone41/computer.gif -format GIF
image create photo uomo -file /scopone41/uomo.gif -format GIF
}
set prog3 0
foreach valo_sco $mazzo {
	set carta_valosco($valo_sco) [lindex $valosco $prog3]
	set carta_valo($valo_sco) [lindex $valo $prog3]
	set carta_valoss($valo_sco) [lindex $valoss $prog3]
	incr prog3
}

for {set bin1 1} {$bin1 < 255} {incr bin1} {
	set binario {}
	set e $bin1
       	for {set g 7} {$g > 0} {incr g -1} {
        	set e1 [expr int($e/pow(2,$g))]
       		set e [expr int($e-($e1*(pow(2,$g))))]
  		lappend binario $e1
	}
        lappend binario $e
	set decbin($bin1) $binario
}

# Crea il menu

 menu:create $w { 
        Partita { 
            Nuova {scelta_giocatori$modalita $w} 
            "Unisciti a partite online" {aggiungi $w} 
         } 
        Help { 
            "Le regole di Chitarella" {regole} 
            Autore {autore} 
        } 
   }


proc scegli_carte  {w} {
set it $w.menubar.mPartita
set label Carte
catch {$it add cascade -label $label -menu $it.r$label}
set radi [menu $it.r$label -tearoff 0]
global tipicarte
set txt Napoletane
set tipicarte 0
$radi add radio -label $txt -variable tipicarte -value 0
set txt Romagnole
$radi add radio -label $txt -variable tipicarte -value 5
set txt Bergamasche
$radi add radio -label $txt -variable tipicarte -value 4
set txt Siciliane
$radi add radio -label $txt -variable tipicarte -value 3
set txt Piacentine                                       
$radi add radio -label $txt -variable tipicarte -value 1
set txt Milanesi
$radi add radio -label $txt -variable tipicarte -value 2


set label "Tipo gioco"
catch {$it add cascade -label $label -menu $it.r$label}
set radi [menu $it.r$label -tearoff 0]
global tipogioco
set txt " a 9 carte"
set tipogioco 9
$radi add radio -label $txt -variable tipogioco -value 9
set txt " a 10 carte"                                       
$radi add radio -label $txt -variable tipogioco -value 10


set label "Modalit"
catch {$it add cascade -label $label -menu $it.r$label}
set radi [menu $it.r$label -tearoff 0]
global modalita
set txt " partita singola"
set modalita 0
$radi add radio -label $txt -variable modalita -value 0
set txt " torneo"                                       
$radi add radio -label $txt -variable modalita -value 1

# catch {$it add cascade -label Uscita -menu $it.rUscita -command exit}

$it add command -label Uscita -underline 1 -command exit

}

scegli_carte $w

proc rotazione {} {
global pc_giocatore ngiocatore chisono magic_number

set b {1 2 3 4 1 2 3}
foreach giocrot {1 2 3 4} {
set pc_giocatore2($giocrot) $pc_giocatore($giocrot)
}

foreach giocrot {1 2 3 4} {
set pc_giocatore($giocrot) $pc_giocatore2([lindex $b $giocrot])
}

foreach giocrot {1 2 3 4} {
if {$chisono == $giocrot} {
set ngiocatore [lindex $b [expr $giocrot + 2] ]
break
}
}


incr magic_number
if {$magic_number > 3} {
set magic_number 0
}
 


}

proc autore {} {
        tk_messageBox -type ok -message "Antonio Iacono \n \n 2009 - antonio2@blia.it"
	return 1
}

proc tiro_io {w carta_scelta ngiocatore2} {
        global numpiatto carta_com url ngiocatore giocatore ngame nturno piatto pc_giocatore carte_pc uscitaciclo uscite_gioc finepa debug messdebug tipogioco modalita 
        set ngiocatore $ngiocatore2

	if {$nturno != $ngiocatore} {
		tk_messageBox -type ok -message " il turno di $giocatore($nturno)"
		return 1
	}

	if {$uscitaciclo == 0} {
                tk_messageBox -type ok -message "Devi premere il tasto <Continua>"
		return 1
	}


        if {[llength $carte_pc($ngiocatore)] == 0 || [expr [llength $uscite_gioc(1)] + [llength $uscite_gioc(2)] + [llength $uscite_gioc(3)] +  [llength $uscite_gioc(4)]] >= [expr $tipogioco * 4]} {
		return 1
	}

	destroy $w.lbl01
	destroy $w.lbl02

	destroy $w.c$carta_scelta
	presa $w $carta_scelta
	regsub $carta_scelta $carte_pc($ngiocatore) {} carte_pc($ngiocatore)

	set cards {}
	lappend cards $carta_scelta
	set cards [concat $cards $carta_com]
        set ngiocatorex $ngiocatore

        if {[cambiaturno $w $ngiocatore $cards] == "finepartita"} {
        return 
        }

        set sommagioc [expr $pc_giocatore(1) + $pc_giocatore(2) + $pc_giocatore(3) + $pc_giocatore(4)]

        if {$sommagioc >= 3 && $sommagioc < 5} {
                set ngiocatoreold $ngiocatore
		set ngiocatore $nturno

			for {set t1 1} {$t1 <= 3} {incr t1} {

                                set gioco [sugg $ngiocatore]

                                if {$debug == 1} {
                                // tk_messageBox -type ok -message "Bug $gioco"
                                }

                                if {[tira_pc $w $gioco $ngiocatoreold] == "finepartita"} {
                                break
                                }

                                if {$debug == 1} {
                                tk_messageBox -type ok -message "$ngiocatore $carte_pc($ngiocatore) $messdebug"
                                }

				set ngiocatore $nturno
			}
                        if {$finepa != 1} {
                                destroy $w.lbl01
				place [label $w.lbl01 -text " il tuo turno"] -x 110 -y 350 
			}
		} else {

                if {[llength $uscite_gioc($ngiocatore)] > 0} {
		set risposta ""
                while {$risposta != [llength $uscite_gioc($ngiocatore)]} {
                set query1 [::http::formatQuery action comcard game $ngame gamer $ngiocatore cards $cards uscite [llength $uscite_gioc($ngiocatore)] modalita $modalita tipogioco $tipogioco]
#                set http  [::http::geturl $url -query $query1]
                set http  [::http::geturl "${url}?$query1"]
                set risposta  [::http::data $http]
                ::http::cleanup $http
                }
                }

                ascolto $w
	}
}

proc trovanome {ng} {
global nome1 nome2 nome3 nome4 magic_number
set nuovom [expr $ng + $magic_number]

if {$nuovom > 4} {
set nuovom [expr $nuovom - 4]
}


if {$nuovom == 1} {
return $nome3
}
if {$nuovom == 2} {
return $nome2
}
if {$nuovom == 3} {
return $nome4
}
if {$nuovom == 4} {
return $nome1
}
return $nuovom

}

proc presa {w carta_scelta} {
        global piatto carta_d carta_v decbin uscite_gioc carta_com ngiocatore modalita
        global giocatore presesn preseeo ultimapresa uscitaciclo scope tipogioco nomigioc

        set nomegiocatore [trovanome $ngiocatore]

	lappend uscite_gioc($ngiocatore) $carta_scelta

	set nonce 1

	# cerca presa singola

	set carta_com "" 

	set iniziale [string range $carta_scelta 0 0]

	foreach cartapiatto "[join [concat $iniziale o] ""] [join [concat $iniziale b] ""] [join [concat $iniziale c] ""] [join [concat $iniziale s] ""]" {
        	if {[lsearch $piatto $cartapiatto] != -1} {
			vis_piatto $w $carta_scelta $cartapiatto
			destroy $w.lbl02
                        if {$modalita == 1} {
                        place [label $w.lbl02 -text "$nomegiocatore prende $carta_d($cartapiatto) con $carta_d($carta_scelta)"] -x 110 -y 350
                        } {
			place [label $w.lbl02 -text "$giocatore($ngiocatore) prende $carta_d($cartapiatto) con $carta_d($carta_scelta)"] -x 110 -y 350 
                        }
                        set uscitaciclo 0
			place [button $w.btn01 -text Continua -command {
			destroy $w.lbl02
			destroy $w.btn01
			set uscitaciclo 1
			}] -x 10 -y 350

			tkwait variable uscitaciclo

		        destroy $w.e$cartapiatto
        		destroy $w.e$carta_scelta
			set carta_com $cartapiatto
        		regsub $cartapiatto $piatto {} piatto
        		set nonce 0
        		break
        		}
	  }

# cerca prese multiple

if {$nonce == 1} {

if {[llength $piatto] > 1} {
set valore_s $carta_v($carta_scelta)
set lb [expr 8-[llength $piatto]]
set comb [expr pow(2,[llength $piatto])-1]

set presemultiple 0
for {set e2 3} {$e2 <= $comb} {incr e2} {
set binario [lrange $decbin($e2) $lb end]
set val_tot 0
set e4 0
        foreach e3 $binario {
                if {$e3 == 1} {
                set indice_piatto [lindex $piatto $e4]
                incr val_tot $carta_v($indice_piatto)
                 }
        incr e4

        }
   if {$val_tot == $valore_s} {
   incr presemultiple     
   }
}


set presemultiple2 0

for {set e2 3} {$e2 <= $comb} {incr e2} {
set binario [lrange $decbin($e2) $lb end]
set val_tot 0
set lista_prese {}
set lista_prese_sigle {}

set e4 0
        foreach e3 $binario {
                if {$e3 == 1} {
                set indice_piatto [lindex $piatto $e4]
                incr val_tot $carta_v($indice_piatto)
                lappend lista_prese $carta_d($indice_piatto)
                lappend lista_prese_sigle $indice_piatto
                 }
        incr e4
        }
        if {$val_tot == $valore_s} {
        incr presemultiple2

         set presa "Prendo le carte: $lista_prese ?"
         destroy $w.w2
         set w2 [frame $w.w2]
         if {$presemultiple == $presemultiple2} {
         set scelta 0
         destroy $w.lbl02
         set prese1 ""
                foreach prese $lista_prese_sigle {
       		append prese1 $carta_d([string trim $prese])
        	append prese1 " "
		}
                        vis_piatto $w $carta_scelta [lindex $lista_prese_sigle 0]
                        if {$modalita == 1} {
                        place [label $w.lbl02 -text "$nomegiocatore prende $prese1 con $carta_d($carta_scelta)"] -x 110 -y 350
                        } {
                        place [label $w.lbl02 -text "$giocatore($ngiocatore) prende $prese1 con $carta_d($carta_scelta)"] -x 110 -y 350
 }

                        
			set uscitaciclo 0
			place [button $w.btn01 -text Continua -command {
			destroy $w.lbl02
			destroy $w.btn01
			set uscitaciclo 1
			}] -x 10 -y 350
	tkwait variable uscitaciclo

         } {
         set scelta [tk_dialog $w2 Presa $presa "" "" Si No]
         }
                if {$scelta == 0} {
                destroy $w.e$carta_scelta
			foreach cartapiatto $lista_prese_sigle {
                        destroy $w.e$cartapiatto
                        regsub $cartapiatto $piatto {} piatto
			}
		set carta_com $lista_prese_sigle
                set nonce 0
                break
                }
        }
     }
  }
}

if {$nonce == 0 && [llength $piatto] == 0 && [expr [llength $uscite_gioc(1)] + [llength $uscite_gioc(2)] + [llength $uscite_gioc(3)] +  [llength $uscite_gioc(4)]] < [expr $tipogioco * 4]} {
incr scope($ngiocatore)

		set compagno 2
		if {$ngiocatore == 1} {set compagno 3}
		if {$ngiocatore == 2} {set compagno 4}
		if {$ngiocatore == 3} {set compagno 1}

place [label $w.e$carta_scelta$ngiocatore -image $carta_scelta] -x [expr (($scope($ngiocatore)+$scope($compagno)) *20) + 10] -y 280
destroy $w.lbl02
       if {$modalita == 1} {

place [label $w.lbl02 -text "$nomegiocatore mette scopa con $carta_d($carta_scelta)"] -x 110 -y 350
} {
place [label $w.lbl02 -text "$giocatore($ngiocatore) mette scopa con $carta_d($carta_scelta)"] -x 110 -y 350
}



}

if {$nonce == 1} {
	lappend piatto $carta_scelta
	vis_piatto $w $carta_scelta ""
        if {$modalita == 1} {
        place [label $w.lbl02 -text "$nomegiocatore tira $carta_d($carta_scelta)"] -x 110 -y 350
} {
	place [label $w.lbl02 -text "$giocatore($ngiocatore) tira $carta_d($carta_scelta)"] -x 110 -y 350

}
	set uscitaciclo 0
	place [button $w.btn01 -text Continua -command {
	destroy $w.lbl02
	destroy $w.btn01
	set uscitaciclo 1
	}] -x 10 -y 350
	tkwait variable uscitaciclo
}

if {[llength $carta_com] > 0} {
        if {$ngiocatore == 2 || $ngiocatore == 4} {
	set presesn [concat $presesn $carta_com $carta_scelta]
	} else {
	set preseeo [concat $preseeo $carta_com $carta_scelta]
	}
	set ultimapresa 1
}

}

proc vis_piatto {w carta_scelta cartapresa} {
	global numpiatto piatto mazzo

        foreach carta $mazzo {
        	destroy $w.e$carta
	}

	set carte_piatto 0

	foreach {carta_piatt} $piatto {
		destroy $w.e$carta_piatt
		place [label $w.e$carta_piatt -image $carta_piatt] -x [string range $numpiatto $carte_piatto [expr $carte_piatto+2]] -y [string range $numpiatto [expr $carte_piatto+3] [expr $carte_piatto+5]]
		incr  carte_piatto 6
	}

	if {$carta_scelta != ""} {
		destroy $w.e$carta_scelta
		place [label $w.e$carta_scelta -image $carta_scelta] -x [string range $numpiatto $carte_piatto [expr $carte_piatto+2]] -y [string range $numpiatto [expr $carte_piatto+3] [expr $carte_piatto+5]]
	}

	if {$cartapresa != ""} {
		destroy $w.e$carta_scelta
		set cartatrovata [expr [lsearch $piatto $cartapresa] * 6]
                place [label $w.e$carta_scelta -image $carta_scelta] -x [expr [string range $numpiatto $cartatrovata [expr $cartatrovata+2]] + 30] -y [expr [string range $numpiatto [expr $cartatrovata+3] [expr $cartatrovata+5]] - 30]
	}

}

proc sugg {ngiocatore2} {
global ngiocatore carte_pc coord piatto carta_v carta_d carta_valo decbin uscite_gioc messdebug debug 

set ngiocatore $ngiocatore2

set trovata 0
set valpiat 0
set scopa 0
set lista_prese2 {}

if {[llength $piatto] == 0} {
return [sugg_scopa] 
}

# controlla se puo' mettere la scopa

        foreach w3 $piatto {
        incr valpiat $carta_v($w3)
        }

set carte_pc($ngiocatore) [sort_mio $carte_pc($ngiocatore) "dis"]
set carte_pc2($ngiocatore) [sort_mio $carte_pc($ngiocatore) "asc"]

if {$valpiat<11} {

        foreach w3 $carte_pc($ngiocatore) {
                if {$carta_v($w3) == $valpiat} {
                set scelta_carta $w3
                set trovata 1
                set lista_prese2 [join $piatto]
                break
                }
        }

}

# controlla prese

if {$trovata == 0} {

set comb [expr pow(2,[llength $piatto])-1]
set lb [expr 8-[llength $piatto]]

set valore_scelta -10000

set carte_pc($ngiocatore) [sort_mio $carte_pc($ngiocatore) "dis"]

foreach w3 $carte_pc($ngiocatore) {

for {set e2 1} {$e2 <= $comb} {incr e2} {
set binario [lrange $decbin($e2) $lb end]
set val_tot 0
set val_tot_rest 0
set lista_prese_sigle {}

        set indi 0

        foreach e3 $binario {
        set indice_carta [lindex $piatto $indi]

                if {$e3 == 1} {
                incr val_tot $carta_v($indice_carta)
                        if {$val_tot > 10} {
                        break
                        }
                lappend lista_prese_sigle $indice_carta
                 } else {
                incr val_tot_rest $carta_v($indice_carta)
                 }

        incr indi
        }

                if {$val_tot == $carta_v($w3)} {
                regsub $w3 $carte_pc2($ngiocatore) {} carte_pc2($ngiocatore)
                if {$val_tot_rest > 10 || [valg $val_tot_rest 1] == 4} {
                set carta_valore 0
                foreach cv1 $lista_prese_sigle {
                incr carta_valore $carta_valo($cv1)
                }
                incr carta_valore $carta_valo($w3)
                        if {($ngiocatore == 2 || $ngiocatore == 4) && [llength $lista_prese_sigle] > 1} {
                        incr carta_valore -500
                        } elseif {($ngiocatore == 1 || $ngiocatore == 3) && [llength $lista_prese_sigle] > 1} {
                        incr carta_valore 200
                        }
                        if {($carta_valore > $valore_scelta)} {
                            if {[contr_singola $lista_prese_sigle $w3] == 0} {
                                set scelta_carta $w3
                                set valore_scelta $carta_valore
                                set trovata 1
                                set lista_prese2 $lista_prese_sigle 
                            }
                        }
                    }     
                }
         }
    }
}

# rispondi compagno

if {$trovata == 0 && [expr [llength $uscite_gioc(1)] + [llength $uscite_gioc(2)] + [llength $uscite_gioc(3)] + [llength $uscite_gioc(4)]] > 2 && $valpiat>=10} {

	foreach w3 $carte_pc2($ngiocatore) {
		set compagno 2
		if {$ngiocatore == 1} {set compagno 3}
		if {$ngiocatore == 2} {set compagno 4}
		if {$ngiocatore == 3} {set compagno 1}

		if {$carta_v($w3) == $carta_v([lrange $uscite_gioc($compagno) end end]) && [no_sette $w3 $piatto] == 0 && $w3 != "7o"} {
			set scelta_carta [no_denari $w3]
       			set trovata 1
       			break
		}
	}
}


if {$trovata == 0} {

foreach w3 $carte_pc2($ngiocatore) {

# controlla doppioni

         foreach multiple {4 3 2} {
             if {[valg $carta_v($w3) 2] == $multiple} {
                if {([expr $carta_v($w3) + $valpiat] > 10 || [valg [expr $carta_v($w3) + $valpiat] 1] == 4) && [no_sette $w3 $piatto] == 0 && !($multiple == 2 && $carta_v($w3) == 7) } {
                set scelta_carta [no_denari $w3]
                set trovata 1
                set messdebug "doppioni"
                break
                }
             }
          }
        if {$trovata == 1} {
        break
        }

     }
}


set vall2 0
set vall 0

if {$trovata == 0 && $valpiat<10} {

	foreach carta2 $carte_pc($ngiocatore) {
		set carta_scopa [expr $carta_v($carta2) + $valpiat]
                set proba 4
         		if {[valg $carta_scopa 1] == $proba} {
            			set vall2 [valg $carta_scopa 0]
                		if {$vall2 > $vall} {
					set vall $vall2
       		        		set scelta_carta [no_denari $carta2]
               				set trovata 1
                                        set messdebug "piatto<10 [valg $carta_scopa 1] "
	                		break
                		}
	          	}
	}
}


# carta con meno valore < 10

if {$trovata == 0 && [llength $carte_pc2($ngiocatore)] > 0 && $valpiat<10} {

#        if {($ngiocatore == 1 || $ngiocatore == 3)} {	}

         set carte_pc2($ngiocatore) [sort_mio $carte_pc2($ngiocatore) "car"]

	foreach carta2 $carte_pc2($ngiocatore) {
                if {[expr $carta_v($carta2) + $valpiat] > 10} {
                	set scelta_carta [no_denari $carta2]
                	set trovata 1
                        set messdebug "meno valore < 10"
                	break
	        }
	}
}


set vall2 0
set vall 0

if {$trovata == 0 && $valpiat<10} {

	foreach carta2 $carte_pc($ngiocatore) {
		set carta_scopa [expr $carta_v($carta2) + $valpiat]
                foreach proba {3 2} {
         		if {[valg $carta_scopa 1] == $proba} {
            			set vall2 [valg $carta_scopa 0]
                		if {$vall2 > $vall} {
					set vall $vall2
       		        		set scelta_carta [no_denari $carta2]
               				set trovata 1
                                        set messdebug "scopa [valg $carta_scopa 1] "
	                		break
                		}
	          	}
		}
	}
}



# carta con meno valore

if {$trovata == 0 && [llength $carte_pc2($ngiocatore)] > 0} {

    #        if {($ngiocatore == 1 || $ngiocatore == 3)} {  }

             set carte_pc2($ngiocatore) [sort_mio $carte_pc2($ngiocatore) "car"]

	foreach carta2 $carte_pc2($ngiocatore) {
        	if {[no_sette $carta2 $piatto] == 0} {
                	set scelta_carta [no_denari $carta2]
                	set trovata 1
                        set messdebug "meno valore"
                	break
	        }
	}
}

if {$trovata == 0 && [llength $carte_pc2($ngiocatore)] == 1} {
                set scelta_carta [lindex $carte_pc2($ngiocatore) 0]
                set trovata 1
}

# presa forzata 

if {$trovata == 0} {

	set vall2 0
	set vall 0

	set lista_prese2 {}

	foreach carta2 $carte_pc($ngiocatore) {

		for {set e2 1} {$e2 <= $comb} {incr e2} {
			set binario [lrange $decbin($e2) $lb end]
			set val_tot 0
			set val_tot_rest 0
			set lista_prese2a {}

		        set indi 0
		        foreach e3 $binario {

                		if {$val_tot > 10} {
			                break
		                }

                		if {$e3 == 1} {
                			incr val_tot $carta_v([lindex $piatto $indi])
					lappend lista_prese2a [lindex $piatto $indi]
		                } else {
			                incr val_tot_rest $carta_v([lindex $piatto $indi])
		                }

			        incr indi
			}				

			if {$carta_v($carta2) == $val_tot} {

			foreach proba {4 3 2 1} {

          if {[valg $val_tot_rest 1] == $proba} {
                set vall2 [valg $val_tot_rest 0]
                	if {$vall2 > $vall} {
			set vall $vall2
        		set scelta_carta [si_denari $carta2]
			set lista_prese2 $lista_prese2a
        	        set trovata 1
	                break
                        }
                     }
                 }
            }
        }
    }
 }

if {$trovata == 0} {

	foreach w3 $carte_pc2($ngiocatore) {
                        if {$w3 != "7o"} {
                        set scelta_carta $w3
        	        set trovata 1
	                break
                        }
        }

}

if {$trovata == 0} {
set scelta_carta [lindex $carte_pc($ngiocatore) [expr int(rand()*[llength $carte_pc($ngiocatore)])]]
if {$debug == 1} {
tk_messageBox -type ok -message "Bug - Scelta casuale"
}
}

if {[llength $lista_prese2] > 0 } {
return "$scelta_carta $lista_prese2"
} else {
return $scelta_carta
}
}

proc no_presa {valore_s piatto} {
global decbin carta_v
set comb [expr pow(2,[llength $piatto])-1]
set lb [expr 8-[llength $piatto]]
set no_carta 0
for {set e2 1} {$e2 <= $comb} {incr e2} {
set binario [lrange $decbin($e2) $lb end]
set val_tot 0

        set indi 0
        foreach e3 $binario {

                if {$val_tot > 10} {
                break
                }

                if {$e3 == 1} {
                incr val_tot $carta_v([lindex $piatto $indi])
                 }

        incr indi

        }
        if {$val_tot == $valore_s} {
        set no_carta 1
        }
    }
return $no_carta
}

proc no_sette {valore_s piatto} {
global decbin carta_v
set comb [expr pow(2,[llength $piatto])-1]
set lb [expr 8-[llength $piatto]]
set no_carta 0
for {set e2 1} {$e2 <= $comb} {incr e2} {
set binario [lrange $decbin($e2) $lb end]
set val_tot 0
set val_tot_rest 0

        set indi 0
        foreach e3 $binario {

                if {$val_tot > 6} {
                break
                }

                if {$e3 == 1} {
                incr val_tot $carta_v([lindex $piatto $indi])
                } else {
                incr val_tot_rest $carta_v([lindex $piatto $indi])
                 }

        incr indi

        }
        if {([expr $val_tot + $carta_v($valore_s)] == 7 || ($val_tot == 1 && $carta_v($valore_s) == 7) || ($val_tot == 2 && $carta_v($valore_s) == 7) || ($val_tot == 3 && $carta_v($valore_s) == 7)) && $val_tot_rest > 10 } {
        set no_carta 1
        }
    }
return $no_carta
}


proc sugg_scopa {} {
global ngiocatore carte_pc coord carta_v

set scelta_carta 0
set vall 0

foreach prob1 {4 3 2} {
foreach w3 $carte_pc($ngiocatore) {
set valgioc [valg $carta_v($w3) 1]

                if {$valgioc == $prob1} {
                set vall2 [valg $carta_v($w3) 0]
                if {$vall2 > $vall} {
		set vall $vall2
		set scelta_carta $w3
                }
		}
                }

        if {$vall > 0} {
        break
        }
    }


return [no_denari $scelta_carta]

}


proc valg {v3 funzione} {
global ngiocatore carte_pc carta_v carta_valosco uscite_gioc uscite_inizio
set ca 0
set uscite ""
if {$funzione <= 1} {
set uscite [concat $uscite_gioc(1) $uscite_gioc(2) $uscite_gioc(3) $uscite_gioc(4) $uscite_inizio]
}
set lista [concat $carte_pc($ngiocatore) $uscite]

        foreach w3 $lista {
                if {$carta_v($w3) == $v3} {
                        if {$funzione >= 1} {
                        incr ca
                        } else {
                        incr ca $carta_valosco($w3)
                        }
                }
        }
return $ca
}

proc no_denari {v4} {
global ngiocatore carte_pc carta_v
set ca 0
set ritorno $v4
        foreach w3 $carte_pc($ngiocatore) {
        if {$carta_v($w3) == $carta_v($v4)} {
           if {[string first o $w3] == -1} {
             set ritorno $w3
           break
          }
        }
        }
return $ritorno
}

proc si_denari {v4} {
global carte_pc carta_v ngiocatore
set ritorno $v4
        foreach w3 $carte_pc($ngiocatore) {
        if {$carta_v($w3) == $carta_v($v4)} {
           if {[string first o $w3] != -1} {
             set ritorno $w3
           break
          }
        }
        }
return $ritorno
}

proc dec2bin {e lunghezza} {
set binario {}
        for {set g [expr $lunghezza-1]} {$g > 0} {incr g -1} {
        set e1 [expr int($e/pow(2,$g))]
        set e [expr int($e-($e1*(pow(2,$g))))]
        lappend binario $e1
        }
        lappend binario $e
return $binario

}

proc contr_singola {lista carta} {
global piatto carta_v
set ritorno 0
   if {[llength $lista] > 1 && [string first [string index $carta 0] $piatto] != -1} {
             set ritorno 1
     }
return $ritorno
}


proc sort_mio {carte ordine} {
global carta_valo carta_valoss

set elenco2 {}
set prog0 0

while {[llength $carte] > 0} {

if {$prog0 >= [llength $carte]} {
set prog0 0
}

set carta1 [lindex $carte $prog0]

set no 0

        foreach elenco4 $carte {
                if {($carta_valo($carta1) < $carta_valo($elenco4) && $ordine == "dis") || ($carta_valo($carta1) > $carta_valo($elenco4) && $ordine == "asc") || ($carta_valoss($carta1) > $carta_valoss($elenco4) && $ordine == "car")} {
                set no 1
                break
                }
        }

                if {$no == 0} {
                lappend elenco2 $carta1
                regsub $carta1 $carte {} carte
                }

incr prog0

}

return $elenco2
}


proc posnomi {w ngiocatore} {
        global nomigioc modalita nome1 nome2 nome3 nome4
        
        if {$modalita == 1} {
#        set est "$nomigioc(1) (Est)"
#        set nord "$nomigioc(2) (Nord)"
#        set ovest "$nomigioc(3) (Ovest)" 
#        set sud "$nomigioc(4) (Sud mazziere)" 
        set est "(Est)"
        set nord "(Nord)"
        set ovest "(Ovest)" 
        set sud "(Sud mazziere)" 

        set posnomi "{$est} {$nord} {$ovest} {$sud} {$est} {$nord} {$ovest}"
        } {
        set posnomi {Est Nord Ovest "Sud (mazziere)" Est Nord Ovest}
        }
#        place [label $w.nomi1 -text [lindex $posnomi $ngiocatore]] -x 580 -y 180
#        place [label $w.nomi2 -text [lindex $posnomi [expr $ngiocatore +2]]] -x 100 -y 180 
#        place [label $w.nomi3 -text [lindex $posnomi [expr $ngiocatore +1]]] -x 380 -y 22 
#        place [label $w.nomi4 -text [lindex $posnomi [expr $ngiocatore -1]]] -x 380 -y 375 

        place [label $w.nomi1 -text "$nome3 [lindex $posnomi $ngiocatore]"] -x 580 -y 180
        place [label $w.nomi2 -text "$nome4 [lindex $posnomi [expr $ngiocatore +2]]"] -x 100 -y 180 
        place [label $w.nomi3 -text "$nome2 [lindex $posnomi [expr $ngiocatore +1]]"] -x 380 -y 22 
        place [label $w.nomi4 -text "$nome1 [lindex $posnomi [expr $ngiocatore -1]]"] -x 380 -y 375 


}


proc inizia_nuova {w} {
global url ngiocatore pc_giocatore giocatori carte_pc nturno noboot tipogioco finepa modalita ngame nome1 nome2 nome3 nome4 
set nturno 1
tipomazzo

        foreach giocoffline {1 2 3 4} {
            if {$pc_giocatore($giocoffline) == 0} {
                set ngiocatore $giocoffline
            }
        }

        set sommagioc [expr $pc_giocatore(1) + $pc_giocatore(2) + $pc_giocatore(3) + $pc_giocatore(4)]

        if {$sommagioc >= 3 && $sommagioc < 5} {
        distribuzione $w
        set noboot 0
        set numero 0

	set carte_pc($ngiocatore) [lsort $carte_pc($ngiocatore)]
	foreach valore $carte_pc($ngiocatore) {
                set comando1 "tiro_io $w $valore $ngiocatore"
                if {$pc_giocatore($ngiocatore) == 1 && $ngiocatore == 4} {
                set comando1 "tk_messageBox -type ok -message \"gioca il computer\""
                }
#                place [button $w.c$valore -image $valore -command $comando1] -x [expr ($numero*70)+10] -y 415
                place [button $w.c$valore -image $valore -command $comando1] -x [expr ($numero*75)+10] -y 390
		incr numero
	}

	place [label $w.e1computer -image computer] -x 340 -y 22 
	place [label $w.e2computer -image computer] -x 90 -y 200 
	place [label $w.e3computer -image computer] -x 580 -y 200 

        posnomi $w $ngiocatore

        if {$pc_giocatore(4) == 1 && $ngiocatore == 4} { 

                        set ngiocatore 1
                        set nturno $ngiocatore


                        for {set t1 1} {$t1 <= [expr $tipogioco * 4]} {incr t1} {
                                set gioco [sugg $ngiocatore]
                                if {$ngiocatore == 4} {
                                set gioco2 [lindex $gioco 0]
                                destroy $w.c$gioco2
                                }
                                tira_pc $w $gioco 4
				set ngiocatore $nturno
			}

        } {

                        if {$ngiocatore != 1} {
                        set ngiocold $ngiocatore
                        set ngiocatore 1
                        set nturno 1

                        for {set t1 1} {$t1 <= [expr $ngiocold -1]} {incr t1} {
                                set gioco [sugg $t1]
                                tira_pc $w $gioco $ngiocold
			}
                        set ngiocatore $ngiocold
                        }

                                destroy $w.lbl01
				place [label $w.lbl01 -text " il tuo turno"] -x 110 -y 350

        }

	return
}

if {!($modalita == 1 && $ngame != "")} {

set query1 [::http::formatQuery action new gamers "$pc_giocatore(1)$pc_giocatore(2)$pc_giocatore(3)$pc_giocatore(4)" modalita $modalita tipogioco $tipogioco nome1 "$nome1" nome2 "$nome2" nome3 "$nome3" nome4 "$nome4"]

if {[catch {set http  [::http::geturl "${url}?$query1"]}]} {
                ::http::cleanup $http
tk_messageBox -type ok -message "Manca la connessione con il server"
return
}

set w1 .finestra
toplevel $w1

wm geometry .finestra 500x200
wm title .finestra "Attendi giocatore..."
wm resizable .finestra no no
wm protocol .finestra WM_DELETE_WINDOW { set giocatori -1}

set risposta  [::http::data $http]
                ::http::cleanup $http

if {[string length $risposta] > 20} {
tk_messageBox -type ok -message "$risposta"
}

place [label $w1.risposta1 -text "Partita creata: [string range $risposta 3 6]"] -x 3 -y 80

set game [string range $risposta 0 end-6]
attesa $game .t .finestra 0

} {

if {$modalita == 1 && $ngame != ""} {
attesa $ngame .t .finestra 1
}
}



}

proc scelta_giocatori0 {w} {
global pc_giocatore punteggio12 punteggio34

cancella $w
set punteggio12 0
set punteggio34 0

set w1 .finestra
toplevel $w1

wm geometry .finestra 400x150
wm title .finestra "Scelta giocatori..."
wm resizable .finestra no no
wm protocol .finestra WM_DELETE_WINDOW { destroy .finestra}


set f2a [frame $w1.f2a]

pack [label $f2a.lbl1 -text "Est        "] -side left
pack [radiobutton $f2a.rb1 -text "Gioc. on line" -variable scelta1 -value 5] -side right
pack [radiobutton $f2a.rb2 -text Tu -variable scelta1 -value 0] -side right
pack [radiobutton $f2a.rb3 -text Computer -variable scelta1 -value 1] -side right
$f2a.rb3 select

pack $f2a -fill x -padx 2 -pady 2


set f1 [frame $w1.f1]

pack [label $f1.lbl1 -text "Nord        "] -side left
pack [radiobutton $f1.rb1 -text "Gioc. on line" -variable scelta -value 5] -side right
pack [radiobutton $f1.rb2 -text Tu -variable scelta -value 0] -side right
pack [radiobutton $f1.rb3 -text Computer -variable scelta -value 1] -side right
pack $f1 -fill x -padx 2 -pady 2
$f1.rb3 select


set f2 [frame $w1.f2]

pack [label $f2.lbl1 -text "Ovest       "] -side left
pack [radiobutton $f2.rb1 -text "Gioc. on line" -variable scelta2 -value 5] -side right
pack [radiobutton $f2.rb2 -text Tu -variable scelta2 -value 0] -side right
pack [radiobutton $f2.rb3 -text Computer -variable scelta2 -value 1] -side right
$f2.rb3 select

pack $f2 -fill x -padx 2 -pady 2

set f3 [frame $w1.f3]

pack [label $f3.lbl1 -text "Sud (Mazziere)"] -side left
pack [radiobutton $f3.rb1 -text "Gioc. on line" -variable scelta3 -value 5 ] -side right
pack [radiobutton $f3.rb2 -text Tu -variable scelta3 -value 0 ] -side right
pack [radiobutton $f3.rb3 -text Computer -variable scelta3 -value 1 ] -side right
$f3.rb2 select

pack $f3 -fill x -padx 2 -pady 2

set f4 [frame $w1.f4]

pack [button $f4.btn1 -text Ok -command { 
destroy .finestra
set sommascelte [expr $scelta1 + $scelta + $scelta2 + $scelta3] 
if {$sommascelte < 3} {
tk_messageBox -type ok -message " possibile scegliere solo un giocatore off-line"
return
}

if {$sommascelte == 20} {
tk_messageBox -type ok -message " possibile scegliere massimo 3 giocatori on-line"
return
}

set pc_giocatore(1) $scelta1
set pc_giocatore(2) $scelta
set pc_giocatore(3) $scelta2
set pc_giocatore(4) $scelta3
inizia_nuova $w}] -side left

pack $f4 -fill x -padx 2 -pady 2

}

proc scelta_giocatori1 {w} {
global pc_giocatore nome1 nome2 nome3 nome4 nomigioc

cancella $w

set w1 .finestra
toplevel $w1

wm geometry .finestra 280x150
wm title .finestra "Scelta giocatori..."
wm resizable .finestra no no
wm protocol .finestra WM_DELETE_WINDOW { destroy .finestra}


set f2a [frame $w1.f2a]

pack [label $f2a.lbl1 -text "Il tuo nome "] -side left
pack [entry $f2a.ent1 -textvariable nome1] -side right

pack $f2a -fill x -padx 2 -pady 2

set f1 [frame $w1.f1]

pack [label $f1.lbl1 -text "tuo compagno "] -side left
# pack [entry $f1.ent1 -textvariable nome2] -side right
pack [radiobutton $f1.rb1 -text "Gioc. on line" -variable scelta -value 5] -side right
pack [radiobutton $f1.rb3 -text Computer -variable scelta -value 1] -side right
pack $f1 -fill x -padx 2 -pady 2
$f1.rb3 select


set f2 [frame $w1.f2]

pack [label $f2.lbl1 -text "1^ avversario "] -side left
# pack [entry $f2.ent1 -textvariable nome3] -side right
pack [radiobutton $f2.rb1 -text "Gioc. on line" -variable scelta2 -value 5] -side right
pack [radiobutton $f2.rb3 -text Computer -variable scelta2 -value 1] -side right
$f2.rb3 select

pack $f2 -fill x -padx 2 -pady 2

set f3 [frame $w1.f3]

pack [label $f3.lbl1 -text "2^ avversario "] -side left
# pack [entry $f3.ent1 -textvariable nome4] -side right
pack [radiobutton $f3.rb1 -text "Gioc. on line" -variable scelta3 -value 5 ] -side right
pack [radiobutton $f3.rb3 -text Computer -variable scelta3 -value 1 ] -side right
$f3.rb3 select

pack $f3 -fill x -padx 2 -pady 2

set f4 [frame $w1.f4]

pack [button $f4.btn1 -text Ok -command { 
destroy .finestra

set b {1 2 3 4 1 2 3}
set a [expr int(rand() * 4)]

set pc_giocatore([lindex $b $a]) 0
set pc_giocatore([lindex $b [expr $a +2]]) $scelta
set pc_giocatore([lindex $b [expr $a +1]]) $scelta2
set pc_giocatore([lindex $b [expr $a +3]]) $scelta3


if {$nome1 == $nome2 || $nome1 == $nome3 || $nome1 == $nome4} {
tk_messageBox -type ok -message "I nomi dei giocatori devono essere diversi"
return
}

if {$scelta == 1} {
set nome2 PCComp
}
if {$scelta2 == 1} {
set nome3 PCAvv1
}
if {$scelta3 == 1} {
set nome4 PCAvv2
}

set nomigioc([lindex $b $a]) $nome1
set nomigioc([lindex $b [expr $a +2]]) $nome2
set nomigioc([lindex $b [expr $a +1]]) $nome3
set nomigioc([lindex $b [expr $a +3]]) $nome4

set magic_number [expr 4 - [lindex $b $a]]

inizia_nuova $w}] -side left

pack $f4 -fill x -padx 2 -pady 2

}

proc aggiungi {w} {
global url ngiocatore giocatori pc_giocatore modalita tipogioco

tipomazzo

set w1 .finestra 
toplevel $w1

wm geometry .finestra 500x300
wm title .finestra "Unisciti ..."
wm resizable .finestra no no

wm protocol .finestra WM_DELETE_WINDOW { 
set giocatori -1
destroy .finestra
return
}

set query1 [::http::formatQuery action list]

if {[catch {set http  [::http::geturl "${url}?$query1"]}]} {
                ::http::cleanup $http
tk_messageBox -type ok -message "Manca la connessione con il server"
destroy .finestra
return
}

set risposta  [::http::data $http]
                ::http::cleanup $http


set oo 0

scrollbar .finestra.scroll -command ".finestra.list yview"

listbox .finestra.list -yscroll ".finestra.scroll set" \
	-width 20 -height 16 -setgrid 1

label .finestra.titolo -text "Partite aperte che attendono giocatori," 
label .finestra.titolo1 -text "doppio click per unirti" 

pack .finestra.titolo -side top 
pack .finestra.titolo1 -side top 

pack .finestra.list .finestra.scroll -side left -fill y -expand 1

bind .finestra.list <Double-1> {

set selezione [selection get]
tk_messageBox -type ok -message "Partita selezionata: [string range $selezione 0 3]"
set query1 [::http::formatQuery action add game "iac[string range $selezione 0 3].new[string index $selezione end]"]
set http  [::http::geturl "${url}?$query1"]
set risposta  [::http::data $http]
                ::http::cleanup $http


set pc_giocatore(1) [string index $risposta 0] 
set pc_giocatore(2) [string index $risposta 1]
set pc_giocatore(3) [string index $risposta 2] 
set pc_giocatore(4) [string index $risposta 3] 

set tipogioco [string index $risposta 4] 
set modalita [string index $risposta 5] 

if {$tipogioco == 1} {
set tipogioco 10
}

destroy .finestra.titolo
destroy .finestra.titolo1
destroy .finestra.list
destroy .finestra.scroll

set ngiocatore 0

set giocmanc [string index $selezione end]


set b {0 1 2 3 4 1 2 3}

        foreach gioconline {1 2 3 4} {
        set gioconline1 $pc_giocatore([lindex $b [expr $gioconline + 1]])$pc_giocatore([lindex $b [expr $gioconline + 2]])$pc_giocatore([lindex $b [expr $gioconline + 3]])
            if {$gioconline1 == "555"} {
                set ngiocatore [lindex $b [expr $gioconline + 4 - $giocmanc]]
                break
            }
        }

if {$ngiocatore == 0} {

        foreach gioconline {1 2 3 4} {
        set gioconline1 $pc_giocatore([lindex $b [expr $gioconline + 1]])$pc_giocatore([lindex $b [expr $gioconline + 2]])$pc_giocatore([lindex $b [expr $gioconline + 3]])
            if {$gioconline1 == "115" || $gioconline1 == "511" || $gioconline1 == "151"} {
                set ngiocatore [lindex $b [expr [string first 5 $gioconline1] + 1 + $gioconline]]
                break
            }
        }

}

if {$ngiocatore == 0} {

        foreach gioconline {1 2 3 4} {
        set gioconline1 $pc_giocatore([lindex $b [expr $gioconline + 1]])$pc_giocatore([lindex $b [expr $gioconline + 2]])$pc_giocatore([lindex $b [expr $gioconline + 3]])
            if {$gioconline1 == "155" || $gioconline1 == "551"} {
                set ngiocatore [lindex $b [expr [string 55 $gioconline1] + 3 - $giocmanc + $gioconline]]
                break
            }
        }

}

if {$ngiocatore == 0} {

        foreach gioconline {1 2 3 4} {
        set gioconline1 $pc_giocatore([lindex $b [expr $gioconline + 1]])$pc_giocatore([lindex $b [expr $gioconline + 2]])$pc_giocatore([lindex $b [expr $gioconline + 3]])
            if {$gioconline1 == "515"} {
                set ngiocatore [lindex $b [expr + 3 - ($giocmanc * 2 -2) + $gioconline]]
                break
            }
        }

}


if {$risposta != "" } {
if {$modalita == 1 } { 

set w1 .finestra
set f2a [frame $w1.f2a]

pack [label $f2a.lbl1 -text "Il tuo nome "] -side left
pack [entry $f2a.ent1 -textvariable nomex] -side right

pack $f2a -fill x -padx 2 -pady 2

set f4 [frame $w1.f4]

pack [button $f4.btn1 -text Ok -command { 
destroy .finestra.f2a
destroy .finestra.f4

set query1 [::http::formatQuery action comnome game "iac[string range $selezione 0 3]"  nome $nomex]
set http  [::http::geturl "${url}?$query1"]
set risposta [::http::data $http] 
                ::http::cleanup $http

attesa "iac[string range $selezione 0 3]" .t .finestra 0}] -side left

pack $f4 -fill x -padx 2 -pady 2

} {
attesa "iac[string range $selezione 0 3]" .t .finestra 0
}

}

}

if {$risposta == "" } {
	place [label .finestra.risposta -text "Non ci sono partite aperte"] -x 30 -y 60
	} else {
	foreach i $risposta {
	set number_game [string range $i end-4 end-1]
		if { $number_game == ".new" } {
                .finestra.list insert $oo "[string range $i end-8 end-5] - gioc. [string index $i end]"
		incr oo 
		}
	}
  }

}


proc pause {time} {
   set wait 0
   after [expr {$time*1000}] {set ::wait 1}
   vwait wait
}

proc attesa {game1 w f nuovapartita} {
        global url ngiocatore nturno ngame giocatori pc_giocatore carte_pc piatto uscite_inizio noboot tipogioco modalita nome1 nome2 nome3 nome4 nomigioc aspetta chisono

        if {$nuovapartita == 0} {
 
	set oo 0
        set giocatori 1

        foreach gioconline {1 2 3 4} {
            if {$pc_giocatore($gioconline) == 5} {
                incr giocatori
            }
        }


	while {$giocatori > 0} {
		set giocatoriv $giocatori
		set query1 [::http::formatQuery action query game $game1]
                set http  [::http::geturl "${url}?$query1"]
		set giocatori [string index [::http::data $http] end-1]
                ::http::cleanup $http

		if {$giocatori > $giocatoriv} {
			set giocatori $giocatoriv
		}

		if {$giocatori == 1} {
                        set testo "Attendi che un altro giocatore si unisca"
                        set testo1 "(usa la chat di Blia.it http://www.blia.it/chat/index.php"
                        set testo2 " canale #blia per comunicare con gli altri giocatori)"
		} else {
                        set testo "Attendi che $giocatori giocatori si uniscano"
                        set testo1 "(usa la chat di Blia.it http://www.blia.it/chat/index.php"
                        set testo2 " canale #blia per comunicare con gli altri giocatori)"
		}

		if {$giocatori > 0} {
                place [label $f.$oo -text $testo] -x 3 -y 3
		incr oo
                place [label $f.$oo -text $testo1] -x 3 -y 23
		incr oo
                place [label $f.$oo -text $testo2] -x 3 -y 43
		incr oo
                pause 1
		destroy $f.$oo
		} else {
		break
		}
	}

destroy $f

if {$giocatori == -1} {
	return
}

        if {$modalita == 1} {
        while {$nome1 == "" || $nome2 == "" || $nome3 == "" || $nome4 == ""} {
        set query1 [::http::formatQuery action queryname game $game1]
        set http  [::http::geturl "${url}?$query1"]
        set nomi [string range [::http::data $http] 0 end-1] 
                ::http::cleanup $http

        set nomi2 [split $nomi |]

        set nome1 [lindex $nomi2 0]
        set nome2 [lindex $nomi2 1]
        set nome3 [lindex $nomi2 2]
        set nome4 [lindex $nomi2 3]

        }

        }

        }

        if {$modalita == 1} {

        while {$aspetta == 0} {
        set query1 [::http::formatQuery action aspetta game $game1 gamer 0 giocatori 0]
        set http  [::http::geturl "${url}?$query1"]
        set aspetta [::http::data $http]
                ::http::cleanup $http
	}

        }

        set b {1 2 3 4 1 2 3}

        foreach giocrot {1 2 3 4} {

                if {$pc_giocatore($giocrot) == 0} {
                set nomigioc([lindex $b [expr $giocrot -1]]) $nome1
                set nomigioc([lindex $b [expr $giocrot +1]]) $nome2
                set nomigioc([lindex $b $giocrot]) $nome3
                set nomigioc([lindex $b [expr $giocrot +2]]) $nome4
                break
                }
        }

        tk_messageBox -type ok -message "Inizia la partita (usa la chat di Blia.it http://www.blia.it/chat/index.php canale #blia per comunicare con gli altri giocatori) "
        set noboot 0
        set chisono $ngiocatore

        if {$tipogioco == 9} {
        while {[llength $piatto] < 4} {
        set query1 [::http::formatQuery action distcard$tipogioco game $game1 gamer 5]
        set http  [::http::geturl "${url}?$query1"]
        set piatto [::http::data $http]
                ::http::cleanup $http
        set uscite_inizio $piatto
        vis_piatto $w "" ""
        }
        }

	set ngame $game1

        while {[llength $carte_pc($ngiocatore)] < $tipogioco} {
        set query1 [::http::formatQuery action distcard$tipogioco game $game1 gamer $ngiocatore]
        set http  [::http::geturl "${url}?$query1"]
	set carte_pc($ngiocatore) [::http::data $http]
                ::http::cleanup $http
	}

	if {[lindex $carte_pc($ngiocatore) 0] == "ZZ"} { 
	tk_messageBox -type ok -message "ERRORE"
	}


        if {($ngiocatore == 2 && $pc_giocatore(3) == 1 && $pc_giocatore(4) == 1 && $pc_giocatore(1) == 1) || ($ngiocatore == 3 && $pc_giocatore(4) == 1 && $pc_giocatore(1) == 1) || ($ngiocatore == 4 && $pc_giocatore(1) == 1)} {
        while {[llength $carte_pc(1)] < $tipogioco} {
        set query1 [::http::formatQuery action distcard$tipogioco game $game1 gamer 1]
        set http  [::http::geturl "${url}?$query1"]
        set carte_pc(1) [::http::data $http]
                ::http::cleanup $http
	}	
	}


        if {($ngiocatore == 1 && $pc_giocatore(2) == 1) || ($ngiocatore == 3 && $pc_giocatore(4) == 1 && $pc_giocatore(1) == 1 && $pc_giocatore(2) == 1) || ($ngiocatore == 4 &&  $pc_giocatore(1) == 1 && $pc_giocatore(2) == 1)} {
        while {[llength $carte_pc(2)] < $tipogioco} {
        set query1 [::http::formatQuery action distcard$tipogioco game $game1 gamer 2]
        set http  [::http::geturl "${url}?$query1"]
	set carte_pc(2) [::http::data $http]
                ::http::cleanup $http
	}
	}	

        if {($ngiocatore == 1 && $pc_giocatore(2) == 1 && $pc_giocatore(3) == 1) || ($ngiocatore == 2 && $pc_giocatore(3) == 1) || ($ngiocatore == 4 && $pc_giocatore(1) == 1 && $pc_giocatore(2) == 1 && $pc_giocatore(3) == 1)} {
        while {[llength $carte_pc(3)] < $tipogioco} {
        set query1 [::http::formatQuery action distcard$tipogioco game $game1 gamer 3]
        set http  [::http::geturl "${url}?$query1"]
	set carte_pc(3) [::http::data $http]
                ::http::cleanup $http
	}	
	}

        if {($ngiocatore == 1 && $pc_giocatore(2) == 1 && $pc_giocatore(3) == 1 && $pc_giocatore(4) == 1) || ($ngiocatore == 3 && $pc_giocatore(4) == 1) || ($ngiocatore == 2 && $pc_giocatore(3) == 1 && $pc_giocatore(4) == 1)} {
        while {[llength $carte_pc(4)] < $tipogioco} {
        set query1 [::http::formatQuery action distcard$tipogioco game $game1 gamer 4]
        set http  [::http::geturl "${url}?$query1"]
	set carte_pc(4) [::http::data $http]
                ::http::cleanup $http
	}	
	}

	set nturno 1
	set numero 0
	set carte_pc($ngiocatore) [lsort $carte_pc($ngiocatore)]
	foreach valore $carte_pc($ngiocatore) {
#                place [button $w.c$valore -image $valore -command "tiro_io $w $valore $ngiocatore"] -x [expr ($numero*70)+10] -y 415
                place [button $w.c$valore -image $valore -command "tiro_io $w $valore $ngiocatore"] -x [expr ($numero*75)+10] -y 390
		incr numero
	}

if {($ngiocatore == 1 && $pc_giocatore(2) == 1) || ($ngiocatore == 2 && $pc_giocatore(3) == 1) || ($ngiocatore == 3 && $pc_giocatore(4) == 1) || ($ngiocatore == 4 && $pc_giocatore(1) == 1) } {
place [label $w.e3computer -image computer] -x 580 -y 200 
} elseif {($ngiocatore == 1 && $pc_giocatore(2) != 1) || ($ngiocatore == 2 && $pc_giocatore(3) != 1) || ($ngiocatore == 3 && $pc_giocatore(4) != 1) || ($ngiocatore == 4 && $pc_giocatore(1) != 1)} {
place [label $w.e3computer -image uomo] -x 580 -y 200 
}

if {($ngiocatore == 1 && $pc_giocatore(3) == 1) || ($ngiocatore == 2 && $pc_giocatore(4) == 1) || ($ngiocatore == 3 && $pc_giocatore(1) == 1) || ($ngiocatore == 4 && $pc_giocatore(2) == 1)} {
place [label $w.e1computer -image computer] -x 340 -y 22 
} elseif {($ngiocatore == 1 && $pc_giocatore(3) != 1) || ($ngiocatore == 2 && $pc_giocatore(4) != 1) || ($ngiocatore == 3 && $pc_giocatore(1) != 1) || ($ngiocatore == 4 && $pc_giocatore(2) != 1)} {
place [label $w.e1computer -image uomo] -x 340 -y 22 
}

if {($ngiocatore == 1 && $pc_giocatore(4) == 1) || ($ngiocatore == 2 && $pc_giocatore(1) == 1) || ($ngiocatore == 3 && $pc_giocatore(2) == 1) || ($ngiocatore == 4 && $pc_giocatore(3) == 1)} {
place [label $w.e2computer -image computer] -x 90 -y 200 
} elseif {($ngiocatore == 1 && $pc_giocatore(4) != 1) || ($ngiocatore == 2 && $pc_giocatore(1) != 1) || ($ngiocatore == 3 && $pc_giocatore(2) != 1) || ($ngiocatore == 4 && $pc_giocatore(3) != 1) } {
place [label $w.e2computer -image uomo] -x 90 -y 200 
}

posnomi $w $ngiocatore

if {$nturno != $ngiocatore} {
	ascolto $w
}

}

proc ascolto {w} {
global url ngiocatore pc_giocatore giocatore ngame nturno piatto uscite_gioc finepa tipogioco modalita
set oo 0
set cards {}
if {[expr [llength $uscite_gioc(1)] + [llength $uscite_gioc(2)] + [llength $uscite_gioc(3)] +  [llength $uscite_gioc(4)]] >= [expr $tipogioco * 4]} {
return
}

if {($ngiocatore == 1 && $nturno == 2 && $pc_giocatore(2) == 1 && $pc_giocatore(1) != 1) || ($ngiocatore == 1 && $nturno == 3 && $pc_giocatore(2) == 1 && $pc_giocatore(3) == 1 && $pc_giocatore(1) != 1) || ($ngiocatore == 2 && $nturno == 3 && $pc_giocatore(3) == 1 && $pc_giocatore(2) != 1) || ($ngiocatore == 2 && $nturno == 4 && $pc_giocatore(4) == 1 && $pc_giocatore(3) == 1 && $pc_giocatore(2) != 1) || ($ngiocatore == 3 && $nturno == 4 && $pc_giocatore(4) == 1 && $pc_giocatore(3) != 0) || ($ngiocatore == 2 && $nturno == 1 && $pc_giocatore(3) == 1 && $pc_giocatore(4) == 1 && $pc_giocatore(1) == 1 && $pc_giocatore(2) != 1) || ($ngiocatore == 3 && $nturno == 1 && $pc_giocatore(4) == 1 && $pc_giocatore(1) == 1 && $pc_giocatore(3) != 1) || ($ngiocatore == 4 && $nturno == 1 && $pc_giocatore(1) == 1 && $pc_giocatore(4) != 1) || ($ngiocatore == 3 && $nturno == 2 && $pc_giocatore(4) == 1 && $pc_giocatore(1) == 1 && $pc_giocatore(2) == 1 && $pc_giocatore(3) != 1) || ($ngiocatore == 4 && $nturno == 2 && $pc_giocatore(1) == 1 && $pc_giocatore(2) == 1 && $pc_giocatore(4) != 1) || ($ngiocatore == 4 && $nturno == 3 && $pc_giocatore(1) == 1 && $pc_giocatore(2) == 1 && $pc_giocatore(3) == 1 && $pc_giocatore(4) != 1)} {

	set ngiocatore_old $ngiocatore
	set ngiocatore $nturno
        set ngiocatoreturno $nturno

        set gioco [sugg $ngiocatore]

	set risposta ""

        if {[tira_pc $w $gioco $ngiocatore_old] == "finepartita"} {
        return finepartita
        }        

        if {[llength $uscite_gioc($ngiocatoreturno)] > 0} {
        while {$risposta != [llength $uscite_gioc($ngiocatoreturno)]} {
                set query1 [::http::formatQuery action comcard game $ngame gamer $ngiocatoreturno cards $gioco uscite [llength $uscite_gioc($ngiocatoreturno)] tipogioco $tipogioco modalita $modalita]
                set http  [::http::geturl "${url}?$query1"]
                set risposta  [::http::data $http] 
                ::http::cleanup $http
	}
	}


	set ngiocatore $ngiocatore_old

        if {[ascolto $w] == "finepartita"} {
                return
        }

	}

if {$ngiocatore != $nturno} {

        while {[llength $cards] < 1} {
                set query1 [::http::formatQuery action querycard game $ngame gamer $nturno gamerq $ngiocatore uscite [llength $uscite_gioc($ngiocatore)] tipogioco $tipogioco]
                set http  [::http::geturl "${url}?$query1"]
		set cards [string range [::http::data $http] 0 end-1] 
                ::http::cleanup $http

                if {$finepa != 1} {
                        place [label $w.attesa -text "Attendi che $giocatore($nturno) tiri la carta"] -x 110 -y 350
                }

                incr oo
                pause 1
		destroy $w.attesa
	}

	set ngiocatore_old $ngiocatore
	set ngiocatore $nturno

        if {[tira_pc $w $cards $ngiocatore_old] == "finepartita"} {
        return finepartita
        }

        if {$nturno == $ngiocatore_old && $finepa != 1} {
                destroy $w.lbl01
		place [label $w.lbl01 -text " il tuo turno"] -x 110 -y 350
	}

	set ngiocatore $ngiocatore_old

	if {$nturno != $ngiocatore} {
	ascolto $w
	}
}
}

proc cambiaturno {w ngioca1 cards} {
global uscite_gioc tipogioco modalita nturno pc_giocatore ngame url

if {[expr [llength $uscite_gioc(1)] + [llength $uscite_gioc(2)] + [llength $uscite_gioc(3)] +  [llength $uscite_gioc(4)]] >= [expr $tipogioco * 4]} {

                if {$ngame != ""} {
                set risposta ""
                while {$risposta != [llength $uscite_gioc(4)]} {
                set query1 [::http::formatQuery action comcard game $ngame gamer 4 cards $cards uscite [llength $uscite_gioc(4)] modalita $modalita tipogioco $tipogioco]
                set http  [::http::geturl "${url}?$query1"]
                set risposta  [::http::data $http] 
                ::http::cleanup $http
		}
                }
fine_partita
set ngiocatorex $ngioca1
cancella $w
set ngiocatore $ngiocatorex

if {$modalita == 1} {
rotazione
                if {$pc_giocatore($ngiocatore) < 5} {
                inizia_nuova $w
                } {
                attesa $ngame .t .finestra 1
                }
}

return finepartita
}

if {$nturno == 4} {
set nturno 1
} {
incr nturno
}

}

proc tira_pc {w gioco ngiocatore_old} {

        global ngiocatore giocatore carta_d piatto uscite_gioc carte_pc presesn
        global preseeo ultimapresa uscitaciclo scope noboot tipogioco modalita nomigioc

        if {$noboot} {
        return
        }

        set nomegiocatore [trovanome $ngiocatore]
        
        set indice {41 1 42 2 43 3 44 4 11 4 12 1 13 2 14 3 21 3 22 4 23 1 24 2 31 2 32 3 33 4 34 1}
	set indice2 [lindex $indice [expr [lsearch $indice $ngiocatore_old$ngiocatore] + 1]]

        set posscope(1) {705 40}
#        set posscope(2) {70 40}
#        set posscope(3) {10 20}
        set posscope(2) {10 40}
        set posscope(3) {705 40}
        set posscope(4) {10 40}

	set carta_scelta [string range $gioco 0 1]

	set prese2 [split [string range $gioco 3 end]]
	set prese1 ""

	if {[llength $prese2] > 0} {
		foreach prese $prese2 {
       		append prese1 $carta_d([string trim $prese])
        	append prese1 " "
		}
	}

	vis_piatto $w $carta_scelta ""

	lappend uscite_gioc($ngiocatore) $carta_scelta
	regsub $carta_scelta $carte_pc($ngiocatore) {} carte_pc($ngiocatore)

	if {[lindex $prese1 0] != ""} {

                if {$ngiocatore == 2 || $ngiocatore == 4} {
			set presesn [concat $presesn $prese2 $carta_scelta]
			} else {
			set preseeo [concat $preseeo $prese2 $carta_scelta]
		}

		set ultimapresa $ngiocatore
		set uscitaciclo 0

		set piattotemp $piatto

		foreach cartapiatto $prese2 {
               	        regsub $cartapiatto $piattotemp {} piattotemp
			}

                if {[llength $piattotemp] > 0 || ([llength $piattotemp] == 0 && [expr [llength $uscite_gioc(1)] + [llength $uscite_gioc(2)] + [llength $uscite_gioc(3)] + [llength $uscite_gioc(4)]] == [expr $tipogioco * 4])} {
			vis_piatto $w $carta_scelta [lindex $prese2 0]
			destroy $w.lbl02
                        if {$modalita == 1} {
                        place [label $w.lbl02 -text "$nomegiocatore prende $prese1 con $carta_d($carta_scelta)"] -x 110 -y 350
                        } {                        
			place [label $w.lbl02 -text "$giocatore($ngiocatore) prende $prese1 con $carta_d($carta_scelta)"] -x 110 -y 350
                        }
                        } else {
			vis_piatto $w $carta_scelta [lindex $piatto 0]
			destroy $w.lbl02
                        if {$modalita == 1} {
                        place [label $w.lbl02 -text "$nomegiocatore mette scopa con $carta_d($carta_scelta)"] -x 110 -y 350
                         } { 
                        place [label $w.lbl02 -text "$giocatore($ngiocatore) mette scopa con $carta_d($carta_scelta)"] -x 110 -y 350
                        }


			incr scope($ngiocatore)

		set compagno 2
		if {$ngiocatore == 1} {set compagno 3}
		if {$ngiocatore == 2} {set compagno 4}
		if {$ngiocatore == 3} {set compagno 1}

               #         if {$indice2 == 2 || $indice2 == 4} {
               #                 place [label $w.e$carta_scelta$ngiocatore -image $carta_scelta] -x [expr (($scope($ngiocatore)+$scope($compagno)) *20) + [lindex $posscope($indice2) 0]] -y [lindex $posscope($indice2) 1] 
                                place [label $w.e$carta_scelta$ngiocatore -image $carta_scelta] -x [lindex $posscope($indice2) 0] -y [expr (($scope($ngiocatore)+$scope($compagno)) * 40) +[lindex $posscope($indice2) 1]]
               #                 } else {
               #                 place [label $w.e$carta_scelta$ngiocatore -image $carta_scelta] -x [lindex $posscope($indice2) 0] -y [expr (($scope($ngiocatore)+$scope($compagno)) * 40) +[lindex $posscope($indice2) 1]]
               #                 }
		}

		foreach cartapiatto $prese2 {
               	        regsub $cartapiatto $piatto {} piatto
			}

		destroy $w.btn01
		set uscitaciclo 0
		place [button $w.btn01 -text Continua -command {
		destroy $w.lbl02
		destroy $w.btn01
		set uscitaciclo 1
		}] -x 10 -y 350

	tkwait variable uscitaciclo

			foreach cartapiatto $prese2 {
                        destroy $w.e$cartapiatto
			}

	vis_piatto $w "" ""

	} else {
	destroy $w.lbl02
                        if {$modalita == 1} {

        place [label $w.lbl02 -text "$nomegiocatore tira $carta_d($carta_scelta)"] -x 110 -y 350
} {
	place [label $w.lbl02 -text "$giocatore($ngiocatore) tira $carta_d($carta_scelta)"] -x 110 -y 350

}

	destroy $w.btn01
	set uscitaciclo 0
	place [button $w.btn01 -text Continua -command {
	destroy $w.lbl02
	destroy $w.btn01
	set uscitaciclo 1
	}] -x 10 -y 350

	tkwait variable uscitaciclo

	vis_piatto $w $carta_scelta ""
	lappend piatto $carta_scelta
	}

        if {[cambiaturno $w $ngiocatore_old $gioco] == "finepartita"} {
        return finepartita
        }

return
}

proc distribuzione {w} {
global carte_pc mazzo piatto uscite_inizio tipogioco

set mazzo2 $mazzo
set mazzo3 {}
set b 40
for {set t 0 } {$t < 40 } {incr t} {
set a [expr int(rand()* $b)]
lappend mazzo3 [lindex $mazzo2 $a]
regsub [lindex $mazzo2 $a] $mazzo2 {} mazzo2
incr b -1
}

if {$tipogioco == 9} {
set carte_pc(1) [lrange $mazzo3 0 8]
set carte_pc(2) [lrange $mazzo3 9 17]
set carte_pc(3) [lrange $mazzo3 18 26]
set carte_pc(4) [lrange $mazzo3 27 35]
set piatto [lrange $mazzo3 36 39]
set uscite_inizio $piatto
vis_piatto $w "" ""
} {
set carte_pc(1) [lrange $mazzo3 0 9]
set carte_pc(2) [lrange $mazzo3 10 19]
set carte_pc(3) [lrange $mazzo3 20 29]
set carte_pc(4) [lrange $mazzo3 30 39]
set uscite_inizio ""
}

}

proc fine_partita {} {
global piatto presesn preseeo ultimapresa scope ngame url uscite_gioc finepa pc_giocatore tipogioco punteggio12 punteggio34 modalita nome1 nome2 nome3 nome4 nomigioc aspetta chisono

if {$modalita == 1} {
set aspetta 0
}

if {$modalita == 0} {
set finepa 1
}

if {[expr $pc_giocatore(1) + $pc_giocatore(2) + $pc_giocatore(3) + $pc_giocatore(4)] > 5} {
set query1 [::http::formatQuery action aspetta game $ngame gamer $chisono giocatori "$pc_giocatore(1)$pc_giocatore(2)$pc_giocatore(3)$pc_giocatore(4)"]
set http  [::http::geturl "${url}?$query1"]
set risposta  [::http::data $http]
                ::http::cleanup $http
}

set puntisn 0
set puntieo 0

# primiera

set punteggioo 0
set punteggioc 0
set punteggiob 0
set punteggios 0

if {$ultimapresa == 2 || $ultimapresa == 4} {
set presesn [concat $presesn $piatto]
} else {
set preseeo [concat $preseeo $piatto]
}

   if {[llength $presesn] > 0} {   
        foreach carta $presesn {
	set carta [string trim $carta]	
	set valorepr [calc_primiera [string index $carta 0]]

           if {[string first o $carta] != -1} {
	      if {$valorepr > $punteggioo} {set punteggioo $valorepr}
	   }

           if {[string first c $carta] != -1} {
	      if {$valorepr > $punteggioc} {set punteggioc $valorepr}
	   }

           if {[string first b $carta] != -1} {
	      if {$valorepr > $punteggiob} {set punteggiob $valorepr}
	   }

           if {[string first s $carta] != -1} {
	      if {$valorepr > $punteggios} {set punteggios $valorepr}
	   }
	}

     }

set primierasn [expr $punteggioo + $punteggios + $punteggiob + $punteggioc]

set punteggioo 0
set punteggioc 0
set punteggiob 0
set punteggios 0

   if {[llength $preseeo] > 0} {   

        foreach carta $preseeo {

	set carta [string trim $carta]	
	set valorepr [calc_primiera [string index $carta 0]]

           if {[string first o $carta] != -1} {
	      if {$valorepr > $punteggioo} {set punteggioo $valorepr}
	   }

           if {[string first c $carta] != -1} {
	      if {$valorepr > $punteggioc} {set punteggioc $valorepr}
	   }

           if {[string first b $carta] != -1} {
	      if {$valorepr > $punteggiob} {set punteggiob $valorepr}
	   }

           if {[string first s $carta] != -1} {
	      if {$valorepr > $punteggios} {set punteggios $valorepr}
	   }
	}
    }

set primieraeo [expr $punteggioo + $punteggios + $punteggiob + $punteggioc]

if {$primierasn > $primieraeo} {
incr puntisn
} elseif {$primierasn < $primieraeo} {
incr puntieo
}

# denari

set denarisn 0
set denarieo 0

        foreach carta $presesn {
           if {[string first o $carta] != -1} {
		incr denarisn
	   }
	}

        foreach carta $preseeo {
           if {[string first o $carta] != -1} {
		incr denarieo
	   }
	}

if {$denarisn > 5} {
incr puntisn
} elseif {$denarisn < 5} {
incr puntieo
}

# carte
set ncartesn [llength $presesn]
set ncarteeo [llength $preseeo]

if {$ncartesn > 20} {
incr puntisn
} elseif {$ncartesn < 20} {
incr puntieo
}

# settebello
set settebellosn 0
set settebelloeo 0

        foreach carta $presesn {
           if {[string first 7o $carta] != -1} {
		incr puntisn
		incr settebellosn
		break
	   }
	}

if {$settebellosn == 0} { 
	incr puntieo 
	incr settebelloeo
}

incr puntisn [expr $scope(2)+$scope(4)]
incr puntieo [expr $scope(1)+$scope(3)]

tk_messageBox -type ok -message "Punteggio finale \n Sud-Nord - Est-Ovest\n punti $puntisn - $puntieo\n carte $ncartesn - $ncarteeo \n denari $denarisn - $denarieo \n settebello $settebellosn - $settebelloeo \n primiera $primierasn - $primieraeo \n scope [expr $scope(2)+$scope(4)] - [expr $scope(1) + $scope(3)]  "


if {$modalita == 1} {

if {$nomigioc(1) == $nome1 || $nomigioc(3) == $nome1} {
incr punteggio12 $puntieo
incr punteggio34 $puntisn
} {
incr punteggio12 $puntisn
incr punteggio34 $puntieo
}

tk_messageBox -type ok -message "Punteggio torneo \n $nome1-$nome2 - $nome3-$nome4\n punti $punteggio12 - $punteggio34"
}

}

proc calc_primiera {valore} {
	set valori_primiera {7 21 6 18 1 16 5 15 4 14 3 13 2 12 f 10 d 10 r 10}
	return [lindex $valori_primiera [expr [lsearch $valori_primiera $valore] + 1]]
}

